package com.szr.zdryztpg.controller;

import com.szr.common.model.BaseResponse;
import com.szr.common.model.PageUtil;
import com.szr.zdryztpg.entity.ZdryJcjdztpgInfo;
import com.szr.zdryztpg.model.*;
import com.szr.zdryztpg.service.ZdryJcjdztpgInfoService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang.time.DateFormatUtils;
import org.springframework.web.bind.annotation.*;
import com.alibaba.excel.EasyExcel;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletResponse;
import java.net.URLEncoder;
import java.util.Date;
import java.util.List;

/**
 * 重点人员监控检查质态评估
 *
 * @author loray
 * @date 2023/9/3 18:39
 */
@Slf4j
@Api(tags = "重点人员检查监督质态评估")
@RestController
@RequestMapping("/zdryztpg")
public class ZdryztpgController {


    @Resource
    private ZdryJcjdztpgInfoService zdryJcjdztpgInfoService;

    @ApiOperation(value = "分页列表")
    @PostMapping("/pageList")
    public BaseResponse<PageUtil<ZtpgPageListVO>> queryCheckInfo(@RequestBody ZtpgPageListDTO params) {
//        PageUtil<CheckInfoPageListVO> pageUtil = new PageUtil<>();
        PageUtil<ZtpgPageListVO> pageUtil = zdryJcjdztpgInfoService.queryPageList(params);
        return BaseResponse.buildResponse()
                .setCode(200)
                .setObj(pageUtil)
                .build();
    }

    @PostMapping("/dataExport")
    @ApiOperation(value = "质态评估数据导出")
    public void dataExport(@RequestBody ZtpgPageListDTO params, HttpServletResponse response) throws Exception {
        List<ZdryJcjdztpgInfo> ztpgPageListVOS = zdryJcjdztpgInfoService.queryList(params);
        response.setContentType("application/vnd.ms-excel");
        response.setCharacterEncoding("utf-8");
        //防止中文乱码
        String fileName = generateFileName();
        fileName = URLEncoder.encode(fileName, "UTF-8").replaceAll("\\+", "%20");
        response.setHeader("Content-disposition", "attachment;filename*=utf-8''" + fileName + ".xlsx");
        // 这里需要设置不关闭流
        EasyExcel.write(response.getOutputStream(), ZdryztpgExportModel.class).autoCloseStream(Boolean.FALSE).sheet("警情巡查数据")
                .doWrite(ztpgPageListVOS);
    }

    private String generateFileName() {
        //自定义文件名
        return "重点人员检查监督-质态评估" + DateFormatUtils.format(new Date(), "yyyyMMddhhmmssSSS");
    }

}
